'use strict';Object.defineProperty(exports,'__esModule',{value:!0}),exports.isShorthand=isShorthand,exports.getLocalizationKey=getLocalizationKey,exports.findChildNode=findChildNode,exports.getExpressionNodes=getExpressionNodes,exports.isNonEmptyText=isNonEmptyText,exports.getLiteralNodes=getLiteralNodes,exports.getComments=getComments,exports.getMessages=getMessages,exports.getAttributesList=getAttributesList,exports.getAllowedAttrs=getAllowedAttrs,exports.findShorthandTranslatableMessages=findShorthandTranslatableMessages,exports.findTranslatableMessages=findTranslatableMessages,exports.getShorthandMessages=getShorthandMessages,exports.getLocalizedMessages=getLocalizedMessages,exports.compileFtlMessages=compileFtlMessages;var _fluentReactComponents=require('fluent-react-components'),_jsxAstUtils=require('jsx-ast-utils'),_constants=require('./constants'),_defaults=require('./defaults'),_formatHelper=require('./format-helper'),JSXElement=_constants.AST_NODE_TYPES.JSXElement,JSXText=_constants.AST_NODE_TYPES.JSXText,JSXExpressionContainer=_constants.AST_NODE_TYPES.JSXExpressionContainer,JSXEmptyExpression=_constants.AST_NODE_TYPES.JSXEmptyExpression,StringLiteral=_constants.AST_NODE_TYPES.StringLiteral,attrs=_constants.FLUENT_ATTRS.attrs,l10nId=_constants.FLUENT_ATTRS.l10nId;function isShorthand(a){var b=1<arguments.length&&arguments[1]!==void 0?arguments[1]:_defaults.defaultShorthandName,c=new RegExp(b+'\\.[A-Z]');return c.test(a)}function getLocalizationKey(){var a=0<arguments.length&&arguments[0]!==void 0?arguments[0]:{},b=1<arguments.length&&arguments[1]!==void 0?arguments[1]:'id',c=(0,_jsxAstUtils.getProp)(a.openingElement.attributes,b),d=c.value.value;if(d)return d;var e=c.value.expression,f=e.name;if(f)return void console.log('l10nId assigned a variable name "'+f+'". This message\n    cannot be automatically extracted. Please ensure that all possible variations\n    of this variable and its messages are added to the ftl file.');var g=e.callee.name;g&&console.log('l10nId assigned a return value for the function "'+g+'".\n    This message cannot be automatically extracted. Please ensure that all possible\n    values of this function and its messages are added to the ftl file.')}function findChildNode(){var a=0<arguments.length&&arguments[0]!==void 0?arguments[0]:{};return a.children.find(function(a){return a.type===JSXElement})}function getExpressionNodes(){var a=0<arguments.length&&arguments[0]!==void 0?arguments[0]:[];return a.filter(function(a){return a.type===JSXExpressionContainer})}function isNonEmptyText(a){return a.type===JSXText&&/\w/.test(a.value)}function getLiteralNodes(){var a=0<arguments.length&&arguments[0]!==void 0?arguments[0]:[];return a.filter(isNonEmptyText)}function getComments(){var a=0<arguments.length&&arguments[0]!==void 0?arguments[0]:{},b=getExpressionNodes(a.children),c=b.filter(function(a){return a.expression.type===JSXEmptyExpression});return c.map(function(a){return a.expression.innerComments[0].value.trim()})}function getMessages(a){var b=getLiteralNodes(a.children);if(b.length)return b.map(function(a){return a.value});var c=getExpressionNodes(a.children),d=c.filter(function(a){return a.expression.type===StringLiteral});return d.map(function(a){return a.expression.value})}function getAttributesList(a){var b=(0,_jsxAstUtils.getProp)(a.openingElement.attributes,attrs),c=b.value.expression.properties;return c?c.map(function(a){return a.key.name}):[]}function getAllowedAttrs(a){var b=1<arguments.length&&void 0!==arguments[1]?arguments[1]:{},c=arguments[2],d=a.split('.')[1],e=Object.assign({},_fluentReactComponents.STANDARD_ELEMENT_TYPES,b),f=e[d];if(f){var g=Object.keys(f);return g.map(function(a){return f[a]?a:''})}return c&&0!==c.length||(console.log('No allowed attributes configured for element type "'+d+'"'),console.log('Add this element to the object under "customElementsPath" in the .l10nrc file, or add a fallback value for string extraction.')),[]}function findShorthandTranslatableMessages(a,b,c){var d=(0,_jsxAstUtils.elementType)(a.openingElement),e=getComments(a),f=getMessages(a),g=getAllowedAttrs(d,c,f),h=(0,_formatHelper.pullLocalizedDOMAttributes)(a,g);return(0,_formatHelper.formatMessage)({messages:f,comments:e,attributes:h,componentType:d,localizationKey:b})}function findTranslatableMessages(a,b){var c=findChildNode(a),d='';if((0,_jsxAstUtils.hasProp)(a.openingElement.attributes,attrs)){var h=getAttributesList(a);d=(0,_formatHelper.pullLocalizedDOMAttributes)(c,h)}var e=getComments(c),f=getMessages(c),g=(0,_jsxAstUtils.elementType)(c.openingElement);return(0,_formatHelper.formatMessage)({messages:f,comments:e,attributes:d,componentType:g,localizationKey:b})}function getShorthandMessages(a,b){var c=getLocalizationKey(a,l10nId),d=findShorthandTranslatableMessages(a,c,b),e=d.message,f=d.comment,g=d.attributes;return(0,_formatHelper.formatRule)({localizationKey:c,comment:f,message:e,attributes:g})}function getLocalizedMessages(a){var b=getLocalizationKey(a),c=findTranslatableMessages(a,b),d=c.message,e=c.comment,f=c.attributes;return(0,_formatHelper.formatRule)({localizationKey:b,comment:e,message:d,attributes:f})}function compileFtlMessages(a,b){var c=b.shorthandName,d=b.customElements,e=(0,_jsxAstUtils.elementType)(a.openingElement);return isShorthand(e,c)?getShorthandMessages(a,d):/Localized/.test(e)?getLocalizedMessages(a):''}